function f  = optimization_func(x , xsmooth, gene, lambda1, lambda2 , R , N,ct,edge_prior,affil)
    f = 0;
    for d = 1: N
        f = f + mean( ((gene(ct(d)+1:ct(d+1))' - x'*xsmooth(:,ct(d)+1:ct(d+1))).^2) / R(d) )  / N ;
%        f = f + sum( ((gene(ct(d)+1:ct(d+1))' - x'*xsmooth(:,ct(d)+1:ct(d+1))).^2) / R(d) ) ;
    end
    
%    fprintf('regression part = %d\n', f);    
    proc = find(x~=0);
    if length(proc) == 0
        f = Inf;
    end
    tempaffil = (1 - edge_prior) * ones(length(affil),1);
    tempaffil(proc(find(affil(proc) == 0))) = edge_prior;
    proc_not_inuse = setdiff(1:length(affil) , proc);
    tempaffil(proc_not_inuse(find(affil(proc_not_inuse) == 1))) = edge_prior;
%   fprintf('before  %g \n',f);
    f = f + lambda1 * sum(tempaffil) + lambda2 * sum(abs(x));
%   fprintf('penalty 1, affil = %d\n', lambda1 * sum(tempaffil));     
%   fprintf('penalty 2, abs = %d\n\n', lambda2 * sum(abs(x)));     
